/*! \file def_glob.h
  \brief globals

*/


// from extern.h
 ptr_definition first_definition;

int arg_c;
char *arg_v[10]; // Modified DJD


 int mem_size;
 int alloc_words;
 GENERIC mem_base;
 GENERIC heap_pointer;
 GENERIC mem_limit;
 GENERIC stack_pointer;

 float garbage_time;
 struct tms life_start,life_end;

 GENERIC other_base;
 GENERIC other_limit;
 GENERIC other_pointer;

 ptr_psi_term error_psi_term;
 long parser_stack_index;

 ptr_node var_tree;
 ptr_node printed_vars;
 ptr_node printed_pointers;
 ptr_node pointer_names;
 long gen_sym_counter;

// long warningflag;
// long verbose;
// long trace
 long noisy;
 long types_done;

 FILE *input_stream;
 long line_count;
 string input_file_name;
 FILE *output_stream;
 char *prompt;
 long page_width;

 /* extern    ptr_psi_term empty_list; 5.8 */
 long type_count;
 long types_modified;
 long main_loop_ok;
 ptr_goal aim;
 ptr_goal goal_stack;
 ptr_choice_point choice_stack;
/*  extern  ptr_choice_point prompt_choice_stack; 12.7 */
 ptr_stack undo_stack;
#ifdef TS
 unsigned long global_time_stamp; /* 9.6 */
#endif

 long assert_first;
 long assert_ok;
 long file_date;

/* The following variables are used to make built-in type comparisons */
/* as fast as possible.  They are defined in built_ins.c.  */
 ptr_definition abortsym; /* 26.1 */
 ptr_definition aborthooksym; /* 26.1 */

 ptr_definition add_module1;  /*  RM: Mar 12 1993  */
 ptr_definition add_module2;
 ptr_definition add_module3;

 ptr_definition and;
 ptr_definition apply;
 ptr_definition boolean;
 ptr_definition boolpredsym;
 ptr_definition built_in;
ptr_definition calloncesym;

 ptr_definition colonsym;
 ptr_definition commasym;
 ptr_definition comment;
/*  extern  ptr_definition conjunction; 19.8 */
 ptr_definition constant;
 ptr_definition cut;
 ptr_definition disjunction;
 ptr_definition disj_nil; /*  RM: Feb 16 1993  */
 ptr_definition eof;
 ptr_definition eqsym;
 ptr_definition leftarrowsym; /* PVR 15.9.93 */
 ptr_definition lf_false;
 ptr_definition funcsym;
 ptr_definition functor;
 ptr_definition iff;
 ptr_definition integer;
 ptr_definition alist;
 ptr_definition life_or; /*  RM: Apr  6 1993  */
 ptr_definition minus_symbol;/*  RM: Jun 21 1993  */
 ptr_definition nil;    /*** RM 9 Dec 1992 ***/
 ptr_definition nothing;
 ptr_definition predsym;
 ptr_definition quote;
 ptr_definition quoted_string;
 ptr_definition real;
 ptr_definition stream;
 ptr_definition succeed;
 ptr_definition such_that;
 ptr_definition top;
 ptr_definition lf_true;
 ptr_definition timesym;
 ptr_definition tracesym; /* 26.1 */
 ptr_definition typesym;
 ptr_definition variable;
 ptr_definition opsym;
 ptr_definition loadsym;
 ptr_definition dynamicsym;
 ptr_definition staticsym;
 ptr_definition encodesym;
 ptr_definition listingsym;
 ptr_definition delay_checksym;
 ptr_definition eval_argsym;
 ptr_definition inputfilesym;
 ptr_definition call_handlersym;
 ptr_definition xf_sym;
 ptr_definition fx_sym;
 ptr_definition yf_sym;
 ptr_definition fy_sym;
 ptr_definition xfx_sym;
 ptr_definition xfy_sym;
 ptr_definition yfx_sym;
 ptr_definition nullsym;
 ptr_definition sys_bitvector;
 ptr_definition sys_regexp;
 ptr_definition sys_stream;
 ptr_definition sys_file_stream;
 ptr_definition sys_socket_stream;

/*  RM: Jul  7 1993  */
 ptr_definition final_dot;
 ptr_definition final_question;

 ptr_psi_term null_psi_term; /* Used to represent an empty parse token */

 ptr_psi_term old_state; /*  RM: Feb 17 1993  */

// from interrupt.h

 long interrupted;

// from login.h

 long stepflag;
 long ignore_eff;
 long goal_count;

// from modules.h
 ptr_module bi_module;      /* Module for public built-ins */
 ptr_module user_module;    /* Default module for user input */
 ptr_module no_module;     
 ptr_module x_module;       /* '#ifdef X11' unnecessary  */
 ptr_module syntax_module;  /* Module for minimal Prolog syntax */
 ptr_node module_table;     /* The table of modules */
 ptr_module current_module; /* The current module for the tokenizer */
 ptr_module sys_module;

 long display_modules;
 long display_persistent;

 long trace_input;

// from parser.h

 long parse_ok;

// from print.h
 char *no_name;
 char *buffer;

/* Global flags that modify how writing is done. */
 long print_depth;
 long indent;
 long const_quote;
 long write_stderr;
 long write_corefs;
 long write_resids;
 long write_canon;

// from token.h

 long stdin_terminal;
 long var_occurred;
/* Part of global input file state */
 long start_of_line;
 long saved_char;
 long old_saved_char;
 ptr_psi_term saved_psi_term;
 ptr_psi_term old_saved_psi_term;
 long eof_flag;

/* File state ADT */
 ptr_psi_term input_state;
 ptr_psi_term stdin_state;
/* For parsing from a string */
 long stringparse;
 char *stringinput;

// from types.h

// from xpred.h
 ptr_psi_term xevent_list, xevent_existing;

 ptr_definition
  xevent, xkeyboard_event, xbutton_event, /* RM: 7.12.92 */
  xexpose_event, xdestroy_event, xmotion_event,
  xdisplay, xdrawable, xwindow, xpixmap, xconfigure_event,
  xenter_event,xleave_event, xmisc_event,  /* RM: 3rd May 93 */
  xgc, xdisplaylist;

 long x_window_creation;

// from lefun.h
 ptr_goal resid_aim;
 ptr_resid_list resid_vars; /* 21.9 */
 ptr_goal resid_limit;
 long curried;
 long can_curry;

// from templates.h

/* defined in templates.c */

// char *numbers[];
//  long set_extra_args[];
char *numbers[21];
long set_extra_args[6];

// from lib.c
jmp_buf env;
char prompt_buffer[PROMPT_BUFFER];

// from lub.c

// from arity.c
FILE *features;

// from built_ins.c
FILE *bi_list;

long (* c_rule[MAX_BUILT_INS])();


char *one;
char *two;
char *three;
char *year_attr;
char *month_attr;
char *day_attr;
char *hour_attr;
char *minute_attr;
char *second_attr;
char *weekday_attr;

// from copy.c
/* TRUE means: heap_flag==TRUE & only copy to heap those objects not */
/* already on heap, i.e. incremental copy to heap.                   */
long to_heap;


// from error.c
long psi_term_line_number;

long warningflag;
long quietflag; /* 21.1 */
long trace;
long verbose; /* 21.1 */
long steptrace;
long stepcount;

// from hash_table.c

long rand_array[256];

// from lefun.c
/* ptr_goal resid_limit; 12.6 */

/* ptr_psi_term match_date; 13.6 */
/* ptr_choice_point cut_point; 13.6 */

// from lib.c

long c_query_level;

// from login.c
/* Statistics on trail cleaning */
long clean_iter;
long clean_succ;

/* ptr_choice_point prompt_choice_stack; 12.7 */

struct tms start_time,end_time;

long xeventdelay;
long xcount;

long more_u_attr; /* TRUE if U has attributes V doesn't */
long more_v_attr; /* Vice-versa */

long u_func,v_func;  /* TRUE if U or V is a curried function */
long new_stat;

ptr_definition *gamma_table;

// from modules.c
string module_buffer;              /* Temporary storage place for strings */

extern long cmp_debug_flag;

// from parser.c
psi_term psi_term_stack[PARSER_STACK_SIZE];
long int_stack[PARSER_STACK_SIZE];
operator op_stack[PARSER_STACK_SIZE];

long no_var_tree;

// from print.c

char *name;
char seg_format[PRINT_POWER+4];

item pretty_things[PRETTY_SIZE];
ptr_item indx;

/* The output stream for a given print command is put in here */
/* This will be set to stdout, to stderr, or to output_stream */
FILE *outfile;

// from sys.c
ptr_definition sys_bytedata; /* DENYS: BYTEDATA */

// from token.c
ptr_node symbol_table;

/* For parsing from a string */
/****************************************************************************/

/* Abstract Data Type for the Input File State */

/* FILE *last_eof_read; */

/* Global input file state information */
/* Note: all characters should be stored in longs.  This ensures
   that noncharacters (i.e., EOF) can also be stored. */
/* For parsing from a string */

// from types.h
ptr_int_list adults,children;
